## Compiler Extension Presentation Instructions

Presentations will take place in the weeks 13-14. 

**The presentation should be 9 minutes long.**

**Q&A session of 5 minutes** will follow right after the
presentation. 

Shortly after, you will receive feedback from us regarding the content
of your presentation, as well as some general feedback on the form.

### Presentation content

Your presentation should summarize your project. In particular, we\'d
expect to see

-   a basic overview of the features you added to the compiler/language
-   some (short) programs highlighting the use of these features, with a
    description of how your extended compiler behaves on them
-   possibly some theoretical background you had to learn about to
    implement the extension
-   an overview of the changes you made to each compiler phase and/or
    which phases you added

### Presentation style

Here are some useful resources on how to prepare and give talks:

-   [How To Speak by Patrick
    Winston](https://www.youtube.com/watch?v=Unzc731iCUY)
-   [How to give a great research talk by Simon Peyton
    Jones](https://www.microsoft.com/en-us/research/academic-program/give-great-research-talk/)

Please do not use Viktor\'s videos as a model for the presentation, but
instead incorporate as many points of the talk of [Patrick
Winston](https://en.wikipedia.org/wiki/Patrick_Winston) as you believe
apply to your presentation. It is an amazing and entertaining talk,
despite (or because) it is meta-circular: he does as he says. Note:
breaking physical objects or referring to supernatural beings in your
video is not required. Use your own judgment and strike a balance in
being comfortable with what and how you are saying things and trying out
these pieces of advice.

### Additional Guidelines
These are guidelines for your project presentation. They must not be followed necessarely but if you have no idea how to start, feel free to use them.

Presentation Structure:

0) Extension Title, Group Number, Names of the group Members
1) Summary: What will we see? (Quickly)
2) An Overview of the extensions with some examples to illustrate
    - What new exciting features does the extension make now possible? 
    - How are these used? 1 example which uses all the new features
3) The main part of the presentation: 
    - Focusing on Project Features
        - For each Feature explain how the different compiler phases were affected 
        - Example: Feature A allows us to do THIS, with SUCH characteristics, and it affects the following phases LIKE THIS
    - Focusing on Compiler Phases
        - For each Compiler Phase explain how each feature affected it (Interpreter?, Lexer, Parser, Name Analyzer, Type Checker, Code Generator)
        - Example: Phase A is affected in THIS way, because of the following features, leading to SUCH characteristics
    - Use examples to help you show the changes
4) Conclusion
    - Conclude the presentation content, very quickly 
    - Present some upgrades or expansions to this project, be critic of your own work
5) Remember to say "Thank You" and transition to the questions section (For example: "Do you have any questions?")

Talking:
- Remember to drink water before the presentation, your mouth will get dry otherwise 
- Remember to articulate
- Remember to finish your sentences
- Remember to divide the presentation evenly between the group members
- Prepare and rehearse your speech

Slides:
- Do not put too much text
- Use examples to take your presentation down to earth

Other Tips:
- Do not be scared to have your speech in a piece of {paper | another document | comments on the slides} to be able to {read | refresh} your memory if you need to
- If you realize you do not have the time to say everything you want, focus on the most important things, and mention the least important parts
